/*
 * cis.h
 */

/*
 * Copyright (c) 1991, 1993 Old Dominion University.
 * Copyright (c) 1991, 1993 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

/* this file contains #define's used in cis_daemon, cis, and
 * cis_interface.
 *
 * written by : Sun W. Chang
 * date	      : April, 1992
 * location   : ODU, Norfolk, Virgina
 * included in: cis_daemon.c
 *              cis.c
 *              cis_interface.c
 */
/* modifications made by  :  Pam Skillman
 * date                   :  December, 1992
 * location               :  ODU, Norfolk, Virginia
*/

#ifndef	TRUE
#define	TRUE	1
#endif

#ifndef FALSE
#define	FALSE	0
#endif

/*
 * XTVSIS protocols
 */
#define	REQUEST_XTVSIS_LIST		21	/* request XTVSIS list */
#define ARE_YOU_ALIVE			22	/* inquire XTV session */
#define	REQUEST_SESSION_INFO		23	/* request session info */
#define	REQUEST_LAST_UPDATE_TIME	24	/* request last time session */
                                                /* list is updated */
#define REGISTRATION			50	/* sessio info about one XTV */
#define	SESSION_INFO			51	/* session info list */
#define	TERMINATION_NOTICE		52	/* termination notice */
#define	XTVSIS_LIST			53	/* XTVSIS list */
#define	LAST_UPDATE_TIME		54	/* last time session list is */						       /* updated */
/*  begin modifications by Pam Skillman */
#define VERSION_REQUEST                 60      /* request version of cis.list */
                                                /* list file */
#define VERSION_REPLY                   61      /* send version of cis list*/
                                                /* file */
#define ID_LIST                         62      /* cis list and version # */
#define ID_LIST_REQUEST                 63      /* request updated cis list*/
/*  end modifications by Pam Skillman  */

#define END_OF_SESSION_ID		(char) 2
#define	END_OF_INFO			(char) 3
#define	END_OF_SESSION			(char) 4

/*  begin modifications by Pam Skillman  */
#define VERSION_SIZE                     2      /* version # is 2 bytes */
/*  end modifications by Pam Skillman  */

#define	HOSTNAME_SIZE			80
#define SESSION_ID_SIZE			113	/* session_id is host:session-number:start-time
						   HOSTNAME_SIZE + 1 + 5(digits) + 1 + 26 = 113 */
#define PACKET_SIZE			10000

#define	TIMEOUT_REGISTRATION		10	/* interval a XTV session sends the REGISTRATION packet*/

#define	TIMEOUT_ARE_YOU_ALIVE		20	/* if any XTVSIS_interface does not 
						   send new session info to any XTVSIS within this time,
						   XTVSIS will send ARE_YOU_ALIVE packet to the
						   XTV session. */
#define	TIMEOUT_LAST_UPDATE_TIME	10	/* XTVSISINT sends
						   REQUEST_LAST_UPDATE_TIME at this interval to
						   XTVSIS. */
#define TIMEOUT_DEAD			80	/* if any XTVSIS_interface does not
						   send new session info to any XTVSIS within this time,
						   XTVSIS will assume the XTV is dead and delete it from its
						   slist. */

#define	XTVSIS_PORT			7000	/* designated XTVSIS port number */

#ifdef SIGTTOU					/* SIGTTOU is defined in BSD but not in System V. So SIGTTOU is */
#define	BSD				1	/* used to identify BSD */
#else
#define SYSV				1
#endif

#define	XTVSIS_LIST_file		"cis.list"
