/*
 * Copyright (c) 1991, 1993 Old Dominion University.
 * Copyright (c) 1991, 1993 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

#include <signal.h>
#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <netinet/in.h>
#include <netdb.h>
#include <X11/X.h>
#include <time.h>


#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include <unistd.h>


#include <X11/Xproto.h>

#include <X11/Xlib.h>

#include <X11/Xresource.h>

#include <X11/Xutil.h>

#include "debug.h"
#include "vs.h"


PrintVS(vs)
   vs_type  *vs;
{
   printf("-------------------   vs   -------------------------\n");
   printf("  title : %s\n",vs->title);
   printf("  virtual root : xid   - 0x%08x\n",vs->virtual_root.window);
   printf("                   x   - %d\n",vs->virtual_root.x);
   printf("                   y   - %d\n",vs->virtual_root.y);
   printf("               width   - %d\n",vs->virtual_root.width);
   printf("              height   - %d\n",vs->virtual_root.height);
   printf("  real    root : xid   - 0x%08x\n",vs->real_root.window);
   /*
   printf("                   x   - %d\n",vs->real_root.x);
   printf("                   y   - %d\n",vs->real_root.y);
   */
   printf("               width   - %d\n",vs->real_root.width);
   printf("              height   - %d\n",vs->real_root.height);
   printf("  real DISPLAY var     : %s\n",vs->real_display_variable);
   printf("  real screen          : %d\n",vs->real_screen);
   printf("----------------------------------------------------\n");
}

PrintFilter(filter) 
   filter_type *filter;
{
   printf("......  filter ..........\n");
   if (filter->is_active) {
      printf("   active,");
   }
   else {
      printf(" inactive,\n");
      return;
   }
   printf(" socket_to_X = %d,",filter->socket_to_X);
   printf(" socket_to_client = %d\n",filter->socket_to_client);
   printf(" root window is 0x%08, at (%d,%d) \n",
          filter->root->window, filter->root->x, filter->root->y);
   /*
   printf(" request_status is %s,",request_name[filter->request_status]);
   */
}
  

