/*
 * Copyright (c) 1991, 1993 Old Dominion University.
 * Copyright (c) 1991, 1993 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

#define  FILTER_NUMBER 32
#define MAXIMUM_SIZE_OF_A_PROTOCOL  65536

#define HANDLE_SETUP_REQUEST  0
#define HANDLE_SETUP_REPLY    1
#define HANDLE_USUAL_PROTOCOL 2

typedef struct {
   Window window;
   int    x,
          y,
          width,
          height;
} root_type;


typedef struct {
   char               title[30];
   root_type          virtual_root,
                      real_root;
   Display            *real_display;
   char               real_display_variable[50];
   int                public_socket;
   char               *virtual_display_variable;
   int                real_screen;
   int                real_X_socket;
   int                number_of_active_filter;
}  vs_type;


struct window_list_struct {
    Window                    window;
    struct window_list_struct *next_window;
};

typedef struct window_list_struct window_list_type;


typedef struct {
   BOOL                is_active;
   int                 socket_to_X,
                       socket_to_client;
   root_type           *root; 
   int                 request_status;
   window_list_type    *bottom_window;
   BOOL                is_window_manager;
   int                 next_action;
   int                 rx, ry;
}  filter_type;


typedef struct {
   BOOL      server_grabbed;
   BOOL      pointer_grabbed;
   BOOL      keyboard_grabbed;
} server_status_type;

    
