/*
 * Copyright (c) 1991, 1993 Old Dominion University.
 * Copyright (c) 1991, 1993 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

/*
	board.c
	board routines

*/

#include "chat.h"
#include "board.h"
#include "subscriber.h"
#include "network.h"
#include "mark1.bitmap"
#include "mark2.bitmap"
#include <stdio.h>

#define  DEBUGInitializeBoard      0&DEBUGON
#define  DEBUGPutChar              0&DEBUGON
#define  DEBUGFreeDraw             0&DEBUGON
#define  DEBUGFreePointer          0&DEBUGON
#define  DEBUGErasor               0&DEBUGON
#define  DEBUGImageID              0&DEBUGON
#define  DEBUGBoardResize          0&DEBUGON
#define  DEBUGImageData            0&DEBUGON
#define  DEBUGdo_copy              0&DEBUGON

#define MAXWIDTH   1000
#define MAXHEIGHT  800

extern int  SessionNumber;
extern int  BOARD;
extern Bool Mode;
extern BYTE LocalSubID;
extern Socket ChatSocket;
extern XImage *Inimage;
extern BYTE  MulticastFlag[];  /* If TRUE, include Subscriber in Multicast*/


Widget whiteboard,board,copy_pop;
GC     egc,gc,pgc;
extern int  boardwidth;
extern int  boardheight;
int  charwidth,charascent, chardescent;
static int  posx,posy,last_posx,last_posy,key_x = -1;
static int  b_count = 0;
static int button;
static int pointer; /* wahab */
static Packege stat_pack;

int boardline, boarddepth;
char *imagedata;
XImage *Inimage;
Pixmap pixmap;

/* wahab pointer */
  XPoint          oldPoints[5], curPoints[5];






InitializeBoard(toplevel)
Widget toplevel;
{

   Widget copy_form,copylabel,copycomm; 
   XGCValues values;
   XFontStruct  *font;
   XSetWindowAttributes attribute;
   long winattribmask = CWBackingStore | CWSaveUnder;
   static Pixmap mark;




static char TITLE[100];
char SessNum[5];

#        if DEBUGInitializeBoard
		fprintf( stderr, "InitializeBoard():\n" );
#        endif


/*
   strcat(TITLE, "White Board/Session#");     
   sprintf(SessNum,"%d/",SessionNumber);
   strcat(TITLE, SessNum);          
*/
/* wahab pointer */
        oldPoints[0].x =  0;   oldPoints[0].y =   0;
        oldPoints[1].x =  6;   oldPoints[1].y =  12;
        oldPoints[2].x =  0;   oldPoints[2].y = -6  ;
        oldPoints[3].x =  6;   oldPoints[3].y =  0 ;
        oldPoints[4].x =  -12; oldPoints[4].y =  -6;

        curPoints[0].x =  0;   curPoints[0].y =   0;
        curPoints[1].x =  6;   curPoints[1].y =  12;
        curPoints[2].x =  0;   curPoints[2].y = -6  ;
        curPoints[3].x =  6;   curPoints[3].y =  0 ;
        curPoints[4].x =  -12; curPoints[4].y =  -6;


   if (Mode)
   	strcat(TITLE, "WhiteBoard/Chairman");
    else 
   	strcat(TITLE, "WhiteBoard/Participant");

   board = XtVaAppCreateShell(GetAppCon(),"xtv",topLevelShellWidgetClass,
                      XtDisplay(toplevel),
                      XtNtitle,     TITLE ,
                      XtNresizable, True,
                       NULL); 

   whiteboard = XtVaCreateManagedWidget("WhiteBoard",formWidgetClass,board,
                      XtNheight,    boardheight,
                      XtNwidth,     boardwidth,
                      XtNresizable, True,
                      NULL);

   XtAddEventHandler(whiteboard, KeyPressMask,FALSE, key_input, NULL);

   XtAddEventHandler(whiteboard, ButtonPressMask,FALSE,start_rubber_band, NULL);

   XtAddEventHandler(whiteboard, ButtonMotionMask,FALSE,track_rubber_band, NULL);

   XtAddEventHandler(whiteboard, ButtonReleaseMask,FALSE,end_rubber_band, NULL);

   XtAddEventHandler(whiteboard, StructureNotifyMask,FALSE,board_resize, NULL);




   copy_pop = XtCreatePopupShell("CopyPop",
                         transientShellWidgetClass,board,NULL,0);
   copy_form = XtCreateManagedWidget("CopyForm",
                         formWidgetClass,copy_pop,NULL,0);

   copylabel = XtVaCreateManagedWidget("CopyLabel",
                   asciiTextWidgetClass,copy_form,
                   XtNeditType ,         XawtextRead,
                   XtNuseStringInPlace,  True,
                   XtNwrap,              XawtextWrapWord,
                   NULL);

   copylabel = XtVaCreateManagedWidget("CopyLabel1",
                   labelWidgetClass,copy_form,
                   XtNheight,   19,
                   XtNwidth,    100,
                   NULL);

   mark = XCreateBitmapFromData(XtDisplay(copy_pop),
            RootWindowOfScreen(XtScreen(copy_pop)),
            mark1_bits,mark1_width,mark1_height);

   copylabel = XtVaCreateManagedWidget("CopyIma1",
                   labelWidgetClass,copy_form,
                   XtNheight,   19,
                   XtNwidth,    25,
                   XtNbitmap,      mark,
                   NULL);
   copylabel = XtVaCreateManagedWidget("CopyLabel2",
                   labelWidgetClass,copy_form,
                   XtNheight,   19,
                   XtNwidth,    100,
                   NULL);

   mark = XCreateBitmapFromData(XtDisplay(copy_pop),
            RootWindowOfScreen(XtScreen(copy_pop)),
            mark2_bits,mark2_width,mark2_height);

   copylabel = XtVaCreateManagedWidget("CopyIma2",
                   labelWidgetClass,copy_form,
                   XtNheight,   19,
                   XtNwidth,    25,
                   XtNbitmap,      mark,
                   NULL);
   copylabel = XtVaCreateManagedWidget("CopyLabel3",
                   labelWidgetClass,copy_form,
                   XtNheight,   19,
                   XtNwidth,    100,
                   NULL);

   mark = XCreateBitmapFromData(XtDisplay(copy_pop),
            RootWindowOfScreen(XtScreen(copy_pop)),
            mark1_bits,mark1_width,mark1_height);

  copylabel = XtVaCreateManagedWidget("CopyIma3",
                   labelWidgetClass,copy_form,
                   XtNheight,   19,
                   XtNwidth,    25,
                   XtNbitmap,      mark,
                   NULL);

   copycomm = XtCreateManagedWidget("Copydone",commandWidgetClass,copy_form,NULL,0);
   XtAddCallback( copycomm, XtNcallback, pre_copy , NULL);

   copycomm = XtCreateManagedWidget("Copycanc",commandWidgetClass,copy_form,NULL,0);
   XtAddCallback( copycomm, XtNcallback, canc_copy , NULL);




   font = XLoadQueryFont(XtDisplay(board),
                       "7x13");

   charwidth =font->max_bounds.width;
   charascent = font->max_bounds.ascent;
   chardescent = font->max_bounds.descent;



   values.font = font->fid;
   values.foreground = BlackPixel(XtDisplay(whiteboard), 
				DefaultScreen(XtDisplay(whiteboard)));
   values.background = WhitePixel(XtDisplay(whiteboard), 
				DefaultScreen(XtDisplay(whiteboard)));

   values.fill_style = FillStippled;
   values.function = GXxor;  /*wahab*/
   values.line_width  = 2;
   values.cap_style = CapRound;
   values.join_style = JoinRound;

   pgc = XtGetGC(whiteboard, GCForeground | GCBackground | 
         GCFunction | GCFillStyle | GCFont | GCLineWidth | GCCapStyle |
                        GCJoinStyle, &values);


   gc = XtGetGC(whiteboard, GCForeground | GCBackground |
                        GCFillStyle | GCFont, &values);

   values.foreground = WhitePixel(XtDisplay(whiteboard), 
				DefaultScreen(XtDisplay(whiteboard)));
   values.background = BlackPixel(XtDisplay(whiteboard), 
				DefaultScreen(XtDisplay(whiteboard)));


   values.fill_style = FillTiled;

   egc = XtGetGC(whiteboard, GCForeground | GCBackground |
                        GCFillStyle | GCFont, &values);


  if (BOARD) {
    XtRealizeWidget(board);
    attribute.backing_store = Always;
    attribute.save_under = True;
    XChangeWindowAttributes(XtDisplay(whiteboard),XtWindow(whiteboard),
                winattribmask,&attribute);

    XGrabButton(XtDisplay(whiteboard), AnyButton,AnyModifier,
              XtWindow(whiteboard), TRUE,
              ButtonPressMask | ButtonMotionMask | ButtonReleaseMask,
              GrabModeAsync, GrabModeAsync,XtWindow(whiteboard),
              XCreateFontCursor(XtDisplay(whiteboard),XC_hand1));

    Inimage = XGetImage(XtDisplay(whiteboard),RootWindow(XtDisplay(whiteboard),
         DefaultScreen(XtDisplay(whiteboard))),0,0,
              5,5,AllPlanes,XYPixmap);

  }
 }




XtEventHandler key_input(w, z, event)
Widget         w;
XtPointer      z;
XEvent         *event;
{

  long statinout;
  int charcount;
  KeySym keysym;
  char  key[5];


  if (b_count) {
     rm_copy();
     return;
   }

  charcount = XLookupString(event,key,5,&keysym, &statinout);
  
  if (event->xkey.x == key_x)
         event->xkey.x = event->xkey.x+charwidth; 
  key_x = event->xkey.x;

  if (keysym >= XK_space && keysym <= XK_asciitilde) {

     if (event->xkey.x >= boardwidth-8 || event->xkey.y >= boardheight-8) XBell(XtDisplay(w),10);
     XWarpPointer(XtDisplay(w), NULL, NULL, 0,0,0,0,charwidth,0);
     XDrawString(XtDisplay(w),XtWindow(w),gc,event->xkey.x,event->xkey.y,key,charcount);

     if (pixmap)
     XDrawString(XtDisplay(w),pixmap,gc,event->xkey.x,event->xkey.y,key,charcount);
   } else 

      if (keysym == XK_BackSpace  ||  keysym ==XK_Delete){

         XWarpPointer(XtDisplay(w), NULL, NULL, 0,0,0,0,-charwidth,0);
         XFillRectangle(XtDisplay(w),XtWindow(w),egc,event->xkey.x-charwidth,
                event->xkey.y-charascent,charwidth,charascent+chardescent);
	 if (pixmap)
         XFillRectangle(XtDisplay(w),pixmap,egc,event->xkey.x-charwidth,
                event->xkey.y-charascent,charwidth,charascent+chardescent);

         } else return;

     stat_pack.id = LocalSubID; 
     stat_pack.flag = BOARD_TYPING;
     stat_pack.x = event->xkey.x;
     stat_pack.y = event->xkey.y;
     stat_pack.p_keysym = keysym;
     strncpy(stat_pack.string,key,charcount);  
     PackegeHandle(&stat_pack);
 
}





XtEventHandler start_rubber_band(w, z, event)
Widget         w;
XtPointer      z;
XEvent         *event;
{

  Arg arg[2];
  int x,y;
  XSetWindowAttributes attrib;

/*
fprintf(stderr,"--------%d--------",b_count);
*/
   switch (event->xbutton.button){
        case Button1: 
                    if (b_count) {
                       rm_copy();
                       break;
		     }
                    posx = event->xbutton.x;
                    posy = event->xbutton.y;
		    if (event->xbutton.state & ShiftMask) { /* wahab */
                    pointer = 1; 
                    curPoints[0].x =  posx;   curPoints[0].y =   posy;
                    XDrawLines(event->xbutton.display,event->xbutton.window,pgc,
                            curPoints,5, CoordModePrevious);
                    stat_pack.id = LocalSubID;
                    stat_pack.flag = BOARD_POINTER_START;
                    stat_pack.p_keysym = 0;
                    stat_pack.x = posx;
                    stat_pack.y = posy;
                    PackegeHandle(&stat_pack);
                    XFlush(event->xbutton.display);
                    }
                    else
                    button = 1;
                    break;

        case Button2: 
                    if (b_count) {
                       rm_copy();
                       break;
		     }
                    posx = event->xbutton.x;
                    posy = event->xbutton.y;
                    
                    XDrawRectangle(XtDisplay(w),XtWindow(w),gc,posx-7,posy-11,14,22); 
		if(pixmap)
                    XDrawRectangle(XtDisplay(w),pixmap,gc,posx-7,posy-11,14,22); 


                    stat_pack.id = LocalSubID; 
                    stat_pack.flag = BOARD_ERASSING;
		    stat_pack.p_keysym = 0;
		    stat_pack.x = posx;
		    stat_pack.y = posy;
                    button = 2;
		    PackegeHandle(&stat_pack);

                    break;

        case Button3:          
                    if (!b_count) {  
                       XtSetArg(arg[0],XtNx,event->xbutton.x_root);
                       XtSetArg(arg[1],XtNy,event->xbutton.y_root);
                       XtSetValues(copy_pop,arg,2);
                       XtPopup(copy_pop,XtGrabNonexclusive);
                       b_count++;
                       break;
                     } else {
                       if (b_count == 3) {
                          x = event->xbutton.x;
                          y = event->xbutton.y;
                          do_copy(x,y);
                          break;
                       }          
                       if(b_count == 1) {
                           last_posx = event->xbutton.x_root;
                           last_posy = event->xbutton.y_root;
                           XChangeActivePointerGrab(XtDisplay(whiteboard),ButtonPressMask,
                               XCreateFontCursor(XtDisplay(whiteboard),XC_bottom_right_corner),
                               CurrentTime);
                       } else {
                            posx = event->xbutton.x_root;  
                            posy = event->xbutton.y_root;
                            XUngrabPointer(XtDisplay(whiteboard),CurrentTime);
                            attrib.cursor = XCreateFontCursor(XtDisplay(whiteboard),
                                        XC_top_left_corner);           
                            XChangeWindowAttributes(XtDisplay(whiteboard),XtWindow(whiteboard),
                                CWCursor,&attrib);
		       }
                       b_count++;
  		     }
	}
}




XtEventHandler track_rubber_band(w, z, event)
Widget         w;
XtPointer      z;
XEvent         *event;
{


/*
      fprintf(stderr,"button = %d", event->xbutton.button);
*/
      if (pointer == 1 || button == 1) { 
                    last_posx = posx;
                    last_posy = posy;
                    posx = event->xbutton.x;
                    posy = event->xbutton.y;

                    if (pointer == 1) { /* wahab */
		  	oldPoints[0].x = last_posx; oldPoints[0].y =   last_posy;
        		curPoints[0].x =  posx;   curPoints[0].y =   posy;

			XDrawLines(event->xbutton.display,event->xbutton.window,pgc,
				oldPoints,5, CoordModePrevious);
			XDrawLines(event->xbutton.display,event->xbutton.window,pgc,
				curPoints,5, CoordModePrevious);
			}
                    else {
                    XDrawLine(event->xbutton.display,event->xbutton.window,gc,
                               last_posx,last_posy,posx,posy);

		    if(pixmap)
                    XDrawLine(event->xbutton.display,pixmap,gc,
                               last_posx,last_posy,posx,posy);
                    }

                    stat_pack.id = LocalSubID;
		    if (pointer == 1)
                        stat_pack.flag = BOARD_POINTER;
                    else 
			stat_pack.flag = BOARD_DRAWING;

		    stat_pack.p_keysym = 0;
		    stat_pack.x = posx;
		    stat_pack.y = posy;
                    stat_pack.x1 = last_posx;
                    stat_pack.y1 = last_posy;
		    PackegeHandle(&stat_pack);
      } else {

                    last_posx = posx;
                    last_posy = posy;
                    posx = event->xbutton.x;
                    posy = event->xbutton.y;
                    
                    XFillRectangle(XtDisplay(w),XtWindow(w),egc,last_posx-7,
                               last_posy-11,15,23);

                    XDrawRectangle(XtDisplay(w),XtWindow(w),gc,posx-7,posy-11,14,22); 
	if(pixmap) {
                    XFillRectangle(XtDisplay(w),pixmap,egc,last_posx-7,
                               last_posy-11,15,23);

                    XDrawRectangle(XtDisplay(w),pixmap,gc,posx-7,posy-11,14,22); 
	}
                    stat_pack.id = LocalSubID; 
                    stat_pack.flag = BOARD_ERASSING;
		    stat_pack.p_keysym = 1;
		    stat_pack.x = posx;
		    stat_pack.y = posy;
                    stat_pack.x1 = last_posx;
		    stat_pack.y1 = last_posy;
		    PackegeHandle(&stat_pack);
 }


 }





XtEventHandler end_rubber_band(w, z, event)
Widget         w;
XtPointer      z;
XEvent         *event;
{

/*
   fprintf(stderr,"=========%d=========",event->xbutton.button);
*/
   
   if (pointer == 1) {
        pointer = 0; 
        posx = event->xbutton.x;
        posy = event->xbutton.y;
        curPoints[0].x =  posx;   curPoints[0].y =   posy;
        XDrawLines(event->xbutton.display,event->xbutton.window,pgc,
        curPoints,5, CoordModePrevious);
        stat_pack.id = LocalSubID;
        stat_pack.flag = BOARD_POINTER_END;
        stat_pack.p_keysym = 0;
        stat_pack.x = posx;
        stat_pack.y = posy;
        PackegeHandle(&stat_pack);

   }
   else
   button = 0;
   switch (event->xbutton.button){
        case Button2: 
                    posx = event->xbutton.x;
                    posy = event->xbutton.y;
                    
                    XFillRectangle(XtDisplay(w),XtWindow(w),egc,posx-7,
                           posy-11,15,23);
	if(pixmap)
                    XFillRectangle(XtDisplay(w),pixmap,egc,posx-7,
                           posy-11,15,23);

                    stat_pack.id = LocalSubID; 
                    stat_pack.flag = BOARD_ERASSING;
		    stat_pack.p_keysym = 2;
		    stat_pack.x = posx;
		    stat_pack.y = posy;
		    PackegeHandle(&stat_pack);

                    break;

		  }

}




XtEventHandler board_resize(w, z, event)
Widget         w;
XtPointer      z;
XEvent         *event;
{
  XWindowChanges values;

#        if DEBUGBoardResize
		fprintf( stderr, "BoardResize() Begin:\n" );
#        endif

 if (event->type == ConfigureNotify){
              if (Mode) { 
                    stat_pack.id = LocalSubID; 
                    stat_pack.flag = BOARD_RESIZING;
                    boardwidth = event->xconfigure.width; 
                    boardheight = event->xconfigure.height;
		    stat_pack.x = event->xconfigure.width;
		    stat_pack.y = event->xconfigure.height;
#        if DEBUGBoardResize
                fprintf( stderr, "BoardResize(): calling PackegeHandle(): %d width  %d height\n",
                stat_pack.x, stat_pack.y );
#        endif

		    PackegeHandle(&stat_pack);

              } else {
		values.width = boardwidth;
		values.height = boardheight;
#        if DEBUGBoardResize
                fprintf( stderr, "BoardResize(): %d width  %d height\n", 
		values.width, values.height );
#        endif
		XConfigureWindow(XtDisplay(board),XtWindow(board),
				 CWWidth | CWHeight,&values);
#        if DEBUGBoardResize
                fprintf( stderr, "BoardResize() End:\n" );
#        endif

	      }
XCopyArea(XtDisplay(whiteboard), pixmap,XtWindow(whiteboard), gc, 0,0, 
boardwidth, boardheight, 0, 0);

                     
  }
}




void Resize(pack)
Packege *pack;
{
  XWindowChanges values;

boardwidth = pack->x;
boardheight = pack->y;
XtResizeWidget(whiteboard,boardwidth,boardheight,1);
values.width = boardwidth;
values.height = boardheight;
XConfigureWindow(XtDisplay(board),XtWindow(board),CWWidth | CWHeight,&values);

}





void canc_copy (w,n,data)
Widget w;
XtPointer n;
XtPointer data;
{
  b_count = 0 ;
  XtPopdown(copy_pop);
}






void pre_copy(w,n,data)
Widget w;
XtPointer n;
XtPointer data;
{

  XGrabPointer(XtDisplay(whiteboard),XtWindow(whiteboard),FALSE,ButtonPressMask,
        GrabModeAsync,GrabModeAsync,None,XCreateFontCursor(XtDisplay(whiteboard),
            XC_top_left_corner),CurrentTime);

  XtPopdown(copy_pop);
}





void do_copy(x,y)
int x,y;
{

  XImage *image;
  int width,height;
  XSetWindowAttributes attrib;
  Subscriber *Who;
  int n,j;
  Packege OutPack;
  
  width = posx-last_posx;
  height = posy-last_posy;

  if (width < 0 || height < 0) {
     rm_copy();
     return;
   }

#  if DEBUGdo_copy
 fprintf (stderr, "do_copy():XGetImage:image %dx%d+%d+%d  -> %d,%d\n",
                  width, height, last_posx, last_posy,x,y);   
#  endif

  image = XGetImage(XtDisplay(whiteboard),RootWindow(XtDisplay(whiteboard),
         DefaultScreen(XtDisplay(whiteboard))),last_posx,last_posy,width,
         height,AllPlanes,XYPixmap);
  if (image) {

    XPutImage(XtDisplay(whiteboard),XtWindow(whiteboard),gc,image,0,0,x,y,width, height);
    if (pixmap)
    XPutImage(XtDisplay(whiteboard),pixmap,gc,image,0,0,x,y,width, height);
  }
  else {
#  if DEBUGdo_copy
        fprintf (stderr, "XGetImage():  unable to get image at %dx%d+%d+%d\n",
                  width, height, last_posx, last_posy);
#  endif
  }
 
  attrib.cursor = XCreateFontCursor(XtDisplay(whiteboard),XC_top_left_arrow);           
  XChangeWindowAttributes(XtDisplay(whiteboard),XtWindow(whiteboard),
                 CWCursor,&attrib);
  b_count = 0;
 
  stat_pack.id = LocalSubID;   
  stat_pack.flag = BOARD_IMAGE_ID;
  stat_pack.p_keysym = image->bytes_per_line;
  stat_pack.depth = image->depth;
  stat_pack.x = x;
  stat_pack.y = y;
  stat_pack.x1 = width;
  stat_pack.y1 = height;
  j = image->bytes_per_line * height * image->depth;

#  if DEBUGdo_copy
fprintf( stderr, "do_copy(): sent stat_pack.id %d stat_pack.flag %d stat_pack.depth %d stat_pack.x %d  stat_pack.y  %d stat_pack.x1  %d stat_pack.y1  %d j %d\n" , 
stat_pack.id, stat_pack.flag, stat_pack.depth, stat_pack.x, stat_pack.y, 
stat_pack.x1, stat_pack.y1, j);
#  endif
bcopy(&stat_pack, &OutPack, sizeof(Packege));
htonConvertChat(&OutPack);

  if (Mode) {

/*
REPLACING THIS FOR LOOP WITH Multicast CALLS
     for ( Who=FirstSubscriber(); Who != NULL; Who=NextSubscriber() ) {

         if (Who->SubscriberID != LocalSubID ) {

#  if DEBUGdo_copy
        fprintf( stderr, "do_copy():Sending image packege to id : %d\n",Who->SubscriberID );
#  endif

           if (Who->ChatConnect != 0) {
              if (SendData( Who->ChatConnect,&OutPack,sizeof(Packege))==ERROR) EndSession();
              if (SendData( Who->ChatConnect,image->data,j)==ERROR) EndSession();

            }
          }
       }
END OF REPLACING LOOP
*/
#  if DEBUGdo_copy
        fprintf( stderr, "do_copy():Sending image packege to participants \n");
#  endif
MulticastFlag[0]=FALSE;
MulticastChat(&OutPack,sizeof(Packege));
MulticastChat(image->data,j);
MulticastFlag[0]=TRUE;

   }
     else 
           if (ChatSocket != 0) {
              if (SendData( ChatSocket,&OutPack,sizeof(Packege))==ERROR) EndSession();
              if (SendData( ChatSocket,image->data,j)==ERROR) EndSession();

            }
}





rm_copy()
{
  XSetWindowAttributes attrib;

  b_count = 0;
  XUngrabPointer(XtDisplay(whiteboard),CurrentTime);
  attrib.cursor = XCreateFontCursor(XtDisplay(whiteboard),XC_top_left_arrow);           
  XChangeWindowAttributes(XtDisplay(whiteboard),XtWindow(whiteboard),
                 CWCursor,&attrib);
}






void PutChar(packege)
Packege *packege;
{

#        if DEBUGPutChar
		fprintf( stderr, "Board : PutChar():\n" );
#        endif

  if (packege->p_keysym >= XK_space && packege->p_keysym <= XK_asciitilde) {

     XDrawString(XtDisplay(whiteboard),XtWindow(whiteboard),gc,packege->x,
                            packege->y,packege->string,1);
     if (pixmap)
	XDrawString(XtDisplay(whiteboard),pixmap,gc,packege->x,
                            packege->y,packege->string,1);

   } else 
  
      if (packege->p_keysym == XK_BackSpace  ||  packege->p_keysym ==XK_Delete){
        XFillRectangle(XtDisplay(whiteboard),XtWindow(whiteboard),
             egc,packege->x-charwidth, packege->y-charascent,charwidth,
              charascent+chardescent);
	if(pixmap)
	XFillRectangle(XtDisplay(whiteboard),pixmap,egc,packege->x-charwidth,
             packege->y-charascent,charwidth,charascent+chardescent);


         }
}





void FreeDraw(packege)
Packege *packege;
{

#        if DEBUGFreeDraw
		fprintf( stderr, "Board : FreeDraw():\n" );
#        endif

   XDrawLine(XtDisplay(whiteboard),XtWindow(whiteboard),gc,packege->x1,
                     packege->y1,packege->x,packege->y);
   if (pixmap)
	XDrawLine(XtDisplay(whiteboard),pixmap,gc,packege->x1,
                     packege->y1,packege->x,packege->y);
 

} 

void FreePointerStart(packege)
Packege *packege;
{

#        if DEBUGFreePointer
                fprintf( stderr, "Board : FreePointerStart():\n" );
#        endif

   curPoints[0].x =  packege->x;   curPoints[0].y =   packege->y;
   XDrawLines(XtDisplay(whiteboard),XtWindow(whiteboard),pgc,
        curPoints,5, CoordModePrevious);
}

void FreePointer(packege)
Packege *packege;
{

#        if DEBUGFreePointer
                fprintf( stderr, "Board : FreePointer():\n" );
#        endif

   oldPoints[0].x = packege->x1; oldPoints[0].y =   packege->y1;
   curPoints[0].x =  packege->x;   curPoints[0].y =   packege->y;

   XDrawLines(XtDisplay(whiteboard),XtWindow(whiteboard),pgc,
        oldPoints,5, CoordModePrevious);
   XDrawLines(XtDisplay(whiteboard),XtWindow(whiteboard),pgc,
        curPoints,5, CoordModePrevious);
}

void FreePointerEnd(packege)
Packege *packege;
{

#        if DEBUGFreePointer
                fprintf( stderr, "Board : FreePointerEnd():\n" );
#        endif

   curPoints[0].x =  packege->x;   curPoints[0].y =   packege->y;

   XDrawLines(XtDisplay(whiteboard),XtWindow(whiteboard),pgc,
        curPoints,5, CoordModePrevious);
}





void Erasor(packege)
Packege *packege;
{

#        if DEBUGErasor
		fprintf( stderr, "Board : Erasor():\n" );
#        endif

  if (!packege->p_keysym) {
     XDrawRectangle(XtDisplay(whiteboard),XtWindow(whiteboard),gc,
               packege->x-7,packege->y-11,14,22);  
	if (pixmap)
	    XDrawRectangle(XtDisplay(whiteboard),pixmap,gc,
               packege->x-7,packege->y-11,14,22);

  }
  else
     if (packege->p_keysym == 1) {
        XFillRectangle(XtDisplay(whiteboard),XtWindow(whiteboard),egc,
        packege->x1-7, packege->y1-11,15,23);
	if (pixmap)
	XFillRectangle(XtDisplay(whiteboard),pixmap,egc,packege->x1-7,
               packege->y1-11,15,23);
        XDrawRectangle(XtDisplay(whiteboard),XtWindow(whiteboard),gc,
               packege->x-7,packege->y-11,14,22);          
	if (pixmap)
	XDrawRectangle(XtDisplay(whiteboard),pixmap,gc,
               packege->x-7,packege->y-11,14,22);


      } else {
           
        XFillRectangle(XtDisplay(whiteboard),XtWindow(whiteboard),egc,
        packege->x-7, packege->y-11,15,23);                
	if (pixmap)
	XFillRectangle(XtDisplay(whiteboard),pixmap,egc,packege->x-7, 
		packege->y-11,15,23);

      }
} 




void ImageData(x,y,j,data,pack)
int x,y,j;
char *data;
Packege *pack;

{
    Subscriber *Who;
    int n;    
Packege OutPack;

#  if DEBUGImageData
        fprintf( stderr, "ImageData(): Start\n");
#  endif
    
    Inimage->data = data;
    XPutImage(XtDisplay(whiteboard),XtWindow(whiteboard),gc,Inimage,0,0,x,y,
              Inimage->width, Inimage->height);

    if (pixmap) 
    XPutImage(XtDisplay(whiteboard),pixmap,gc,Inimage,0,0,x,y,
              Inimage->width, Inimage->height);
    if (Mode) {


/*
REPLACING THIS FOR LOOP WITH Multicast CALLS

     for ( Who=FirstSubscriber(); Who != NULL; Who=NextSubscriber() ) {

         if (Who->SubscriberID == LocalSubID ) continue;
         if (Who->SubscriberID != pack->id) {

#  if DEBUGImageData
        fprintf( stderr, "ImageData(): Sending image packege to id : %d\n",Who->SubscriberID );
#  endif

           if (Who->ChatConnect != 0) {
bcopy(pack, &OutPack, sizeof(Packege));
htonConvertChat(&OutPack);
              if (SendData( Who->ChatConnect,&OutPack,sizeof(Packege))==ERROR) EndSession();
              if (SendData( Who->ChatConnect,data,j)==ERROR) EndSession();
            }
          }
       }
END OF REPLACING LOOP
*/
#  if DEBUGdo_copy
        fprintf( stderr, "do_copy():Sending image packege to participants \n");
#  endif

MulticastFlag[0]=FALSE;
MulticastFlag[pack->id]=FALSE;
bcopy(pack, &OutPack, sizeof(Packege));
htonConvertChat(&OutPack);
MulticastChat(&OutPack,sizeof(Packege));
MulticastChat(data,j);
MulticastFlag[0]=TRUE;
MulticastFlag[pack->id]=TRUE;

   }

    XtFree(data); 

}

extern int BoardMapped;

short send_board_init( port )
Socket port;
{
  XImage *image;
  int j, jnetwork ;

XFlush(XtDisplay(whiteboard));


    image = XGetImage(XtDisplay(whiteboard),pixmap,
         0, 0 , boardwidth, boardheight,AllPlanes,XYPixmap);
  j = image->bytes_per_line;
  jnetwork = htonl(j);
  if (SendData( port, &jnetwork, sizeof(int) )==ERROR) return ( 1 ) ;

  j = image->depth;
  jnetwork = htonl(j);

  if (SendData( port, &jnetwork, sizeof(int) )==ERROR) return ( 1 ) ;

  j =  image->bytes_per_line * boardheight * image->depth;

  if (SendData( port, image->data, j )==ERROR) return ( 1 ) ;

  XDestroyImage ( image ) ;
  return ( 0 );
}

void get_board_init ( port )
Socket port ;
{
  int *i, j ;

  i = (int *) ReadData( port, sizeof(int), TRUE );
  boardline = ntohl(*i) ;

  i = (int *) ReadData( port, sizeof(int), TRUE );
  boarddepth = ntohl(*i) ;

  j = boardline * boardheight * boarddepth ;
  imagedata = ( char * )ReadData( port, j, TRUE );
}

SetUpInitialBoard (Outer)
Widget Outer;
{

        XWindowAttributes wa;

  XFlush(XtDisplay(whiteboard)) ;
  XGetWindowAttributes(XtDisplay(whiteboard), XtWindow(Outer),&wa);

  pixmap = XCreatePixmap( XtDisplay(whiteboard), XtWindow(Outer),MAXWIDTH,MAXHEIGHT , wa.depth) ;
      XFillRectangle( XtDisplay(whiteboard), pixmap, egc, 0, 0, MAXWIDTH, MAXHEIGHT ) ;

  if ( !Mode )
    {
      Inimage->width = boardwidth;
      Inimage->height = boardheight;
      Inimage->bytes_per_line = boardline;
      Inimage->depth = boarddepth;
      Inimage->data = imagedata ;

      XPutImage(XtDisplay(whiteboard),pixmap,gc,Inimage,0,0,
                  0, 0 ,Inimage->width,Inimage->height);
      XPutImage(XtDisplay(whiteboard),XtWindow(whiteboard),gc,Inimage,0,0,
                  0, 0 ,Inimage->width,Inimage->height);
      XtFree ( imagedata ) ;
    }
}
