/*

 * Copyright (c) 1991, 1993 Old Dominion University.
 * Copyright (c) 1991, 1993 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

/*
   main.c
   Main program module

*/

#define   DEBUGMain   0&DEBUGON

#include <stdio.h>

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Toggle.h>
#include <signal.h>


#include "subscriber.h"
#include "tool.h"
#include "network.h"
#include "protocol.h"
#include "token.h"  
#include "resources.h"
#include "popups.h"

int catch_PIPE_sig();

BYTE VERBOSE=1; /* means no reports of in/out packets (default is ON, every 10 packets) */
BYTE JOIN=1; /* 0 means late joiners will not get old tools */
BYTE POPUP=1; /* 0 means to not intervene in popoups and fix them */
BYTE POLICY = 1; /* 0  means to reminder message policy */
BYTE XCOLOR = 1; /* 0 means not to translate color */
BYTE MULTICAST = 0 ; /* 1 means turn on group multicast messages */
BYTE SEQNUM=1; /* 1 means use circular queue for sequnece numbers */

int CHAT = 1;  /* for zhong_y */
int BOARD = 1;  /* for zhong_y */
BYTE SIS = 1;  /* for sission info service (JR) */

/* wang_x add */
BYTE RESIZE = 1; /* wang_x* 0 means not resize window *wang_x */
/* end wang_x add */


int MinFloorTime = MINFLOORTIME;
int OutputCount = 10;
int GroupCount = 25;
BOOL TimeOutFlag = FALSE;


/* begin JR addition */
#define SUBJECT_SIZE    100
/* end JR addition */

char HHostName[100];

/* begin JR addition */
char    Subject[SUBJECT_SIZE];
int             SessionNumber;
/* end JR addition */

char    INITIAL_MSG1[1024] = {
   "Welcome to XTV -- X Teleconferencing and Viewing --\n    A Framework for Sharing X Window Clients\n                  VERSION 3.0\n"};


/* begin Ramesh's modification for VS-XTV */
BYTE VS = 1;  /* Virtual Screen is ON by default */
int pipefd[2];
char pipestr[10];

char vswm[10]="twm";
char vstitle[100] = "VirtualScreen";
char SesNum[10];
int child;

/* end VS-XTV modification */
Widget      Outer;
Widget      TopLevel;
Widget   WExit;
extern Widget    WSubscriberDrop;
extern OutputCount ;
extern Widget    WToolSToken;
extern Widget    WToolJoin;
extern Widget    board;
extern Widget    chat_top;
extern void CloseAllTools();
extern void CleanUpAllTools();
extern BYTE  MulticastFlag[];  /* If TRUE, include Subscriber in Multicast*/

Window vs_window;


/* ---------------------------------------------------------------------------------- */

Bool      Mode = FALSE;      /* TRUE if in Host mode */

Bool GetMode()
{
   return Mode;
}


XtAppContext   AppCon;

XtAppContext GetAppCon()
{
   return AppCon;
}

/* ---------------------------------------------------------------------------------- */


Widget GetTopLevelWidget()
{
   return TopLevel;
}

/* ---------------------------------------------------------------------------------- */

void InitializeQuit();

void main(argc, argv)
int argc;
char **argv;
{
   Arg     arg;
   static String   Chair_title = "XTV Control Panel : Chairman                  V3.0";
   static String   Parts_title  = "XTV Control Panel : Participant                  V3.0";
   int             pid;/* AKR 05/08 */

   FILE *fp,*fopen();

   Arg      *ArgL;

   siginterrupt(SIGALRM, 1);
   siginterrupt(SIGPIPE, 1);
/*
   signal (SIGPIPE, catch_PIPE_sig);
*/
#if DEBUGMain
   fprintf( stderr, "main()\n" );
#endif

   TopLevel = XtAppInitialize(   &AppCon,      /* Application Context */
   "xtv",          /* Class */
   NULL, ZERO,      /* Args? */
   &argc, argv,      /* Command-line arguments */
   FallbackResources,   /* Default Resources */
   NULL, ZERO);

   /* Build all widgets */

   /* begin JR addition */
   *Subject = '\0';          /* default subject is NO subject */
   /* end JR addition */

   /* Interpret options */
   while (--argc > 0 && (*++argv)[0] == '-') {

      char   *s;


      for (s = argv[0] + 1; *s; s++)
         switch (*s) {

         case 'H':
            fprintf( stderr, "Chairman Usage: %s  [-BCHJPRTVZF] [-G n] [-M wm] [-O n] [-R n] [-S srting]\n\n", 
			argv[-1]);
            fprintf( stderr, "Participant Usage: %s  [-M wm] [-O n]  host_name session_number\n\n", 
			argv[-1] );
            fprintf (stderr, "Options are:\n");
            fprintf (stderr, "B (To Turn OFF White Board window)\n");
            fprintf (stderr, "C (To Turn OFF Chat window)\n");
            fprintf (stderr, "H (To Display this help message)\n");
            fprintf (stderr, "I (To Turn OFF sesssion Info reporting)\n");
            fprintf (stderr, "G (Turn on Group Multicasting messages)\n");
            fprintf (stderr, "J (To Turn OFF Dynamic Joining feature)\n");
            fprintf (stderr, "M (To specify Window Manager inside the VS)\n");
            fprintf (stderr, "       Current default value is twm\n");
            fprintf (stderr, "O n (To Control Output messages, )\n");
            fprintf (stderr, "       n=0 no output, otherwise produce message every n packets, default value of n is 10");
            fprintf (stderr, "P (To Turn OFF PopUp Menues feature )\n");
            fprintf (stderr, "R n (To Change Token Reminder Message to be every n seconds\n");
            fprintf (stderr, "       Current default value of n is %d seconds)\n", MINFLOORTIME/1000);
            fprintf (stderr, "S subject (To give a Subject for a new XTV session)\n");
            fprintf (stderr, "T (To Turn OFF Color Translations)\n");
            fprintf (stderr, "V (To Turn OFF VS  window)\n");
            fprintf (stderr, "Z (To Turn OFF resize  window)\n");
            fprintf (stderr, "F (Fast XTV, as if using the options: )\n");
            exit( 0 );
            break;
         case 'O':
            if (!*++argv || sscanf(*argv,"%d",&OutputCount)==0){
                fprintf(stderr, "no argument specified for -O\n");
		exit(2);
            }
#if DEBUGMain
printf("the value of OutputCount is %d\n", OutputCount);
#endif
            if (OutputCount == 0)
            	VERBOSE = 0;
	    argc--;
            break;
         case 'G': /* MITRE Multicasting */
               MULTICAST = 1;
               VERBOSE = 0; /* turn off Verbose if multicast is ON */
            if (!*++argv || sscanf(*argv,"%d",&GroupCount)==0){
                fprintf(stderr, "no argument specified for -G\n");
                exit(2);
            }
#if DEBUGMain
/*
printf("the value of GroupCount is %d\n", GroupCount);
*/
#endif
            if (GroupCount == 0)
                MULTICAST = 0;
            argc--;
               break;
         case 'J': /* chungg code -UNC */
            JOIN = 0;
            break;
         case 'T': /* zhong code -ODU */
            CHAT = 0;
            break;
         case 'B': /* zhong code -ODU */
            BOARD  = 0;
            break;
         case 'V': /* radha code -ODU */
            VS = 0;
            break;
         case 'R': /* wahab code */
            POLICY = 1;
            if (!*++argv || sscanf(*argv,"%d",&MinFloorTime)==0){
	       fprintf(stderr, "no argument specified for -R\n");
               exit(2);
            }
            MinFloorTime *= 1000;
            if (MinFloorTime < MINFLOORTIME){
               MinFloorTime = MINFLOORTIME;
               fprintf(stderr,"Minimum Floor Time cannot be less than %d seconds\n",
               MINFLOORTIME/1000);
            }
#if DEBUGMain
            fprintf( stderr, "main(): Minimum floor time is %d seconds\n", MinFloorTime/1000);
#endif
            argc--;
            break;

         case 'S':  /* rives code -ODU */
            if (!*++argv)
            {
               fprintf(stderr, "no subject specified for -S\n");
               exit(2);
            };
            if (strlen(*argv) < SUBJECT_SIZE)
               strcpy(Subject, *argv);
            else
            {
               strncpy(Subject, *argv, SUBJECT_SIZE-1);
               Subject[SUBJECT_SIZE-1] = '\0';
            }
            argc--;
            break;

         case 'M':  /* wahab code -ODU */
            if (!*++argv)
               fprintf(stderr, "no window manager specified, will use twm\n");
            strcpy(vswm, *argv);
            argc--;
            break;
         case 'Z': /* wang code -ODU */
            RESIZE = 0;
            break;
         case 'P':  /* lu code -UNC */
            POPUP = 0;
            break;
         case 'C':  /* lu code -UNC */
            XCOLOR = 0;
            break;
         case 'I':  /* JR code -ODU */
            SIS = 0;
            break;

         case 'Q':  /* kants_g code -ODU */
            SEQNUM = 0;
            break;

         case 'F':  /* Fast -set options: BCJPTWZ */
            BOARD  = 0;
            XCOLOR = 0;
            JOIN = 0;
            POPUP = 0;
            CHAT = 0;
            VS = 0;
            VERBOSE = 0;
            RESIZE = 0;
            SEQNUM = 0;
            break;
         default:
            fprintf (stderr, "Unknown option: -%c\n\n", *s);
            fprintf (stderr, "Options are:\n");
            fprintf (stderr, "B (To Turn OFF balckboard window)\n");
            fprintf (stderr, "C (To Turn OFF Color Translations)\n");
            fprintf (stderr, "H (To Display this help message)\n");
            fprintf (stderr, "J (To Turn OFF Dynamic Joining feature)\n");
            fprintf (stderr, "P (To Turn OFF PopUp Menues feature )\n");
            fprintf (stderr, "R n (To Change Token Reminder Message to be every n seconds\n");
            fprintf (stderr, "       Current default value of n is %d seconds)\n", MINFLOORTIME/1000);
            fprintf (stderr, "S (To give a subject for a new XTV session)\n");
            fprintf (stderr, "T (To Turn OFF talk window)\n");
            fprintf (stderr, "V (To Turn ON  Verbose Mode)\n");
            fprintf (stderr, "Z (To Turn ON  resize Mode)\n");
            exit( 0 );
         }
   }
   fflush(stdout);
   if (argc > 3) {
      fprintf( stderr, "Usage: %s host_name session_number\n", argv[0] );
      exit( 1 );
   }

   if ( argc == 2 ) {
#if DEBUGMain
      fprintf( stderr, "main(): Subscriber: Try to contact seession %d at host %s\n",
      atoi(argv[argc -1])-1 , argv[argc -2] );
#endif
      strcpy(HHostName,argv[argc -2]);
      if ( TryToSubscribe(argv[argc -2], atoi(argv[argc -1])-1) < 0 )
         exit(1);
   } 
   else {
#if DEBUGMain
      fprintf( stderr, "main(): Chairman Mode\n");
#endif
      Mode = TRUE;
   }



   Outer = XtCreateManagedWidget( "MainBox", formWidgetClass, TopLevel, NULL, 0 );
   /* Added 01 */
   if (Mode) {

      /* begin JR addition */
      char Full_Chair_title[100];

      if (*Subject)       /* add subject to title bar if specified */
/*Comment  this Untill the subsrciber can also add the title 
         sprintf(Full_Chair_title, "%s   [Subject: %s]", Chair_title, Subject);
*/
         strcpy(Full_Chair_title, Chair_title);
      else
         strcpy(Full_Chair_title, Chair_title);

      XtSetArg(arg,XtNtitle, Full_Chair_title);
      /* end JR addition */

      XtSetValues(TopLevel, &arg, 1);
   }
   else {
      XtSetArg(arg, XtNtitle, Parts_title);
      XtSetValues(TopLevel, &arg, 1);
   }

   /* begin JR change (added &SessionNumber) */
   InitializeSubscriber( AppCon, Outer, Mode, argv[argc -1], &SessionNumber);
   /* end JR addition */

   InitializeChat(TopLevel,argv[argc -2]);  /*  for zhong_y*/
if(BOARD)
   InitializeBoard(TopLevel);               /*  for zhong_y */


   /* begin Sun W. Chang addition */
   if (Mode)
      /* must be called after InitializeSubscriber */
      if (SIS)
      xtvsis_interface(SessionNumber);
   /* end Sun W. Chang addition */

   /* begin Ramesh's modification for VS-XTV */

   /* Fork the VS program as a child of XTV. Later VS has to write its virtual */
   /* root window ID to /tmp/VS_radha_s so that we can read that file later on */
   /* see VS code for the appropriate changes */

   if (VS) {
/*
      sprintf(SesNum,"%d",SessionNumber);   
      strcat(vstitle, SesNum);             
*/
      if (GetMode())
         strcat(vstitle,"/Chairman");
      else
         strcat(vstitle,"/Participant");

      if (pipe(pipefd) == -1) {
         perror("VS pipe");
         VS = 0;
      }
      if (( child = fork()) == 0 ) {
         close(pipefd[0]);
         sprintf(pipestr, "%d", pipefd[1]);
         if ( (execlp("vs","vs",pipestr, vswm, "-bg", "white", "-fg", "black", "-title", vstitle, "=700x500", (char *)0) ) == (-1) ) {
            perror("VS process can not be created");
            exit(0);
         }
      }
      close(pipefd[1]);
      if ((fp = fdopen(pipefd[0],"r")) == NULL) {
         perror("opening VS pipe for read");
         perror("No VS \n");
         VS = 0;
      } 
      else {
         fscanf(fp,"0x%08x",&vs_window);
#if DEBUGMain
      fprintf( stderr, "main(): got vs_window \n");
#endif

/* Gary Carlosn modification
         fclose(fp);
*/
      }
   }

   /* end VS-XTV modification */
   InitializeTool( AppCon, Outer, Mode );
   InitializeUtilities( AppCon, Outer, Mode );
   InitializeMisc( AppCon, Outer);
   InitializePacketTranslator();
   InitializeQuit( AppCon, Outer, Mode);
   InitializeAllPopUps();

#if DEBUGMain
   fprintf( stderr, "main(): Initialized\n" );
#endif


   /* Crank it up! */

   XtRealizeWidget(TopLevel);   
   XFlush(XtDisplay(TopLevel));
if (BOARD)
   SetUpInitialBoard(Outer) ;

   if (!Mode) {
      XtUnmapWidget(WSubscriberDrop);
      XtUnmapWidget(WToolSToken);
   }
   else
      XtUnmapWidget(WToolJoin);


   /*
    * Begin Murray Addition
    *
    * For those shells that don't automatically append a return, here it is.
    *
    */
     printf("\r");
     /*
    * End Murray Addition
    */
   
     XtAppMainLoop(AppCon);
   }
   
/*
   catch_PIPE_sig()
   {
#if DEBUGMain
     fprintf( stderr, "catch_PIPE_sig(): Tool Terminated \n");
     fflush(stderr);
#endif
   }
*/
   
   
   
   
   XtCallbackProc QuitSession (w, client_data, call_data)
   Widget   w;
   caddr_t client_data, call_data;
   {
     XtSetSensitive(WExit, FALSE);
     PopUpBox(w, TranShell[Quit], call_data);
   }
   
   XtCallbackProc CancelQuitProc (w, client_data, call_data)
   Widget   w;
   caddr_t client_data, call_data;
   {
     XtPopdown(TranShell[Quit]);
     XtSetSensitive(WExit, TRUE);
   }
   
   XtCallbackProc ConfirmQuitProc (w, client_data, call_data)
   Widget   w;
   caddr_t client_data, call_data;
   {
     Subscriber      *Who;
   
   
     XtPopdown(TranShell[Quit]);
     XtSetSensitive(WExit, TRUE);
   
     if ( GetMode() ) {
   
   
       /* begin Sun W. Chang addition */
   send_TERMINATION_NOTICE();
   /* end Sun W. Chang addition */

   /* begin Ramesh's modification for VS-XTV */
   if (VS)

      kill(child, SIGKILL);

   /* end VS-XTV modification */
   /* If in host mode, send everybody a HS_EndSession */

/*
Replacing this for loop with Multicast calls
*/

   for ( Who=FirstSubscriber(); Who != NULL; Who = NextSubscriber()) {
      if (Who->SubscriberID != 0) {
         fprintf( stderr, "Quit(): Terminating %s\n", Who->LoginName );
         if (SendByte( Who->Connection, HS_EndSession )==ERROR) CleanUpSubscriber(Who);
      }
   }
/*
end of Replacing  loop 
*/

/*
MulticastFlag[0]=FALSE;
MulticastByte(HS_EndSession);
MulticastFlag[0]=TRUE;
*/
   CleanUpAllTools();


} 
else {

   /* If a subscriber, politely bow out */

   extern Socket SubscriberSocket;   /* Our connection to the host */
   /* begin Ramesh's modification for VS-XTV */
   if(VS)
      kill(child, SIGKILL);

   /* end VS-XTV modification */

   if (SendByte( SubscriberSocket, SH_LeavingSession )==ERROR) EndSession();
   CloseAllTools();
}

/*
 * Begin Murray Addition
 */
  /*
 * This is purely for debugging purposes.
 * Now that the message buffer works, it's not needed.
 *
 *      dumpMessageBuffer();
 */

  /*
 * This may not be necessary, but it's the right thing to do
 */
  freeMessageBuffer();
  /*
 * End Murray Addition
 */

  XtDestroyWidget((Widget)client_data);
  exit(0);
}

void InitializeQuit( AppCon, Outer, Mode)
XtAppContext AppCon;
Widget Outer;
Bool Mode;      /* TRUE if in 'host' mode */
{
   WExit = XtCreateManagedWidget( "QuitButton", commandWidgetClass, Outer, NULL, 0 );
   XtAddCallback( WExit, XtNcallback, QuitSession, TranShell[Quit]);
}

