/*

 * Copyright (c) 1991, 1993 Old Dominion University.
 * Copyright (c) 1991, 1993 University of North Carolina at Chapel Hill.
 * All rights reserved.
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  Old Dominion University and the University of North
 * Carolina at Chapel Hill make no representations about the
 * suitability of this software for any purpose.  It is provided "as is"
 * without express or implied warranty.
 */

/*
   utilities.c
   Create utilities buttions inside the main board
*/

#define   DEBUGUtilities   0&DEBUGON

#include <stdio.h>

#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Toggle.h>
#include <signal.h>



#include "subscriber.h"
#include "popups.h"
extern Widget    TopLevel;
extern Widget    board;
extern Widget    chat_top;
extern Window vs_window;
extern int BOARD; 
extern int CHAT;
extern BYTE VS;

InitializeUtilities( AppCon, Outer, Mode )
XtAppContext AppCon;
Widget Outer;
Bool Mode;      /* TRUE if in 'host' mode */
{
Widget      WUtilities;
Widget      WUtilitiesLabel;
#if DEBUGUtilities
	fprintf(stderr,"InitializeUtilities: Started\n");
#endif
WUtilities = XtCreateManagedWidget( "UtilitiesPanel", formWidgetClass, Outer, NULL, 0 );
WUtilitiesLabel = XtCreateManagedWidget( "Label", labelWidgetClass, WUtilities, NULL, 0);
InitializeChatButton(AppCon,WUtilities);
InitializeBoardButton(AppCon,WUtilities);
InitializeVirtualScreenButton(AppCon,WUtilities);
}


InitializeVirtualScreenButton(appcon,parent)
XtAppContext appcon;
Widget parent;
{
Widget VSbutton;
Arg      arg [5];
int      n;
static void VSButtonCallback();

#if DEBUGUtilities
        fprintf(stderr,"InitializeVirtualScreenButton: Started\n");
#endif


 n = 0 ;
  if ( VS )
    {
      XtSetArg(arg[n],XtNsensitive, True ); n++ ;
    }
  else
    {
      XtSetArg(arg[n],XtNsensitive, False ); n++ ;
      XtSetArg(arg[n],XtNforeground, 1 ); n++ ;
      XtSetArg(arg[n],XtNbackground, 0 ); n++ ;
    }

VSbutton = XtCreateManagedWidget("VirScreen",toggleWidgetClass,parent,arg,n);
XtAddCallback( VSbutton, XtNcallback, VSButtonCallback, vs_window);

}

InitializeBoardButton(appcon,parent)
XtAppContext appcon;
Widget parent;
{
Widget BoardButton;
Arg      arg [5];
int      n;
static void BoardButtonCallback();

#if DEBUGUtilities
        fprintf(stderr,"InitializeBoardButton: Started\n");
#endif


 n = 0 ;
  if ( BOARD )
    {
      XtUnmapWidget(board);
      XtSetArg(arg[n],XtNsensitive, True ); n++ ;
    }
  else
    {
      XtSetArg(arg[n],XtNsensitive, False ); n++ ;
      XtSetArg(arg[n],XtNforeground, 1 ); n++ ;
      XtSetArg(arg[n],XtNbackground, 0 ); n++ ;
    }

BoardButton = XtCreateManagedWidget("Board",toggleWidgetClass,parent,arg,n);
XtAddCallback( BoardButton, XtNcallback, BoardButtonCallback, board);
}

InitializeChatButton(appcon,parent)
XtAppContext appcon;
Widget parent;
{
Widget ChatButton;
Arg      arg [5];
int      n;
static void ChatButtonCallback();

#if DEBUGUtilities
        fprintf(stderr,"InitializeChatButton: Started\n");
#endif

 n = 0 ;
  if ( CHAT )
    {
      XtUnmapWidget(chat_top);
      XtSetArg(arg[n],XtNsensitive, True ); n++ ;
    }
  else
    {
      XtSetArg(arg[n],XtNsensitive, False ); n++ ;
      XtSetArg(arg[n],XtNforeground, 1 ); n++ ;
      XtSetArg(arg[n],XtNbackground, 0 ); n++ ;
    }

ChatButton = XtCreateManagedWidget("Chat",toggleWidgetClass,parent,arg,n);
XtAddCallback( ChatButton, XtNcallback, ChatButtonCallback, chat_top);
}

static void VSButtonCallback(w,data , call_data)
Widget    w;
Window data;
XtPointer call_data;
{

static int VSMapped = TRUE;

#if DEBUGUtilities
        fprintf(stderr,"VSButtonCallback: VSMapped is %d\n", VSMapped);
#endif


  if (VSMapped) {
     XUnmapWindow(XtDisplay(TopLevel),data);
     VSMapped = FALSE;
  }
  else{
     XMapWindow(XtDisplay(TopLevel),data);
/*
     SetPlaceWindow(data,TopLevel);
*/
     VSMapped = TRUE;
  }
}

static void ChatButtonCallback(w,data , call_data)
Widget    w,data;
XtPointer call_data;
{

static int ChatMapped = FALSE;

#if DEBUGUtilities
        fprintf(stderr,"ChatButtonCallback: ChatMapped is %d\n", ChatMapped);
#endif

  if (ChatMapped) {
     XtUnmapWidget(data);
     ChatMapped = FALSE;
  }
  else{
     SetPlace(data,TopLevel);
     XtMapWidget(data);
     ChatMapped = TRUE;
  }
}

int BoardMapped = FALSE;

static void BoardButtonCallback(w,data , call_data)
Widget    w,data;
XtPointer call_data;
{


#if DEBUGUtilities
        fprintf(stderr,"BoardButtonCallback: BoardMapped is %d\n", BoardMapped);
#endif

  if (BoardMapped) {
     XtUnmapWidget(data);
     BoardMapped = FALSE;
  }
  else{
     SetPlace(data,TopLevel);
     XtMapWidget(data);
     BoardMapped = TRUE;
  }
}

